/*
 * n01
 *
 * n01_caller.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <shlobj.h>

#include "../n01_plugin.h"

#include "resource.h"

/* Define */
#define	INI_FILE_NAME				TEXT("n01_caller.ini")

/* Global Variables */
HINSTANCE hInst;

static TCHAR ini_path[BUF_SIZE];
static TCHAR snd_path[MAX_PATH];
static int snd_enable;

/* Local Function Prototypes */
static BOOL CALLBACK option_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * DllMain - C
 */
int WINAPI DllMain(HINSTANCE hInstance, DWORD fdwReason, PVOID pvReserved)
{
	TCHAR work_path[MAX_PATH];
	TCHAR *p, *r;

	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		hInst = hInstance;
		// AvP[ṼpX擾
		GetModuleFileName(hInst, work_path, MAX_PATH - 1);
		for (p = r = work_path; *p != TEXT('\0'); p++) {
#ifndef UNICODE
			if (IsDBCSLeadByte((BYTE)*p) == TRUE) {
				p++;
				continue;
			}
#endif	// UNICODE
			if (*p == TEXT('\\') || *p == TEXT('/')) {
				r = p;
			}
		}
		*r = TEXT('\0');
		wsprintf(ini_path, TEXT("%s\\%s"), work_path, INI_FILE_NAME);

		GetPrivateProfileString(TEXT("SOUND"), TEXT("path"), TEXT(""), snd_path, BUF_SIZE - 1, ini_path);
		snd_enable = GetPrivateProfileInt(TEXT("SOUND"), TEXT("enable"), 1, ini_path);

		if (*snd_path != TEXT('\0') &&
			*(snd_path + lstrlen(snd_path) - 1) != TEXT('\\') && *(snd_path + lstrlen(snd_path) - 1) != TEXT('/')) {
			lstrcat(snd_path, TEXT("\\"));
		}
		break;

	case DLL_PROCESS_DETACH:
		break;

	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

/*
 * get_plugin_info - vOC擾
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		index - 擾̃CfbNX (0`)
 *		pgi - vOC擾
 *
 *	߂l:
 *		TRUE - Ɏ擾vOC
 *		FALSE - 擾̏I
 */
__declspec(dllexport) BOOL CALLBACK get_plugin_info(const HWND hWnd, const int index, PLUGIN_GET_INFO *pgi)
{
	switch (index) {
	case 0:
		lstrcpy(pgi->title, TEXT("n01_&caller"));
		lstrcpy(pgi->func_name, TEXT("n01_caller"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;

	case 1:
		return FALSE;
	}
	return FALSE;
}

/*
 * func_plugin_initialize - vOC̏
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		pei - vOCs
 *
 *	߂l:
 *		vOČĂяo@
 *
 *	l:
 *		֐ vOC_initialize
 */
__declspec(dllexport) BOOL CALLBACK n01_caller_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	// ߂lɌĂяo@̑gݍ킹ݒ肷
	return (CALLTYPE_START | CALLTYPE_MENU | CALLTYPE_LEG_START | CALLTYPE_INPUT_END | CALLTYPE_FINISH);
}

/*
 * func_plugin_property - vOC̃vpeB
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		pei - vOCs
 *
 *	߂l:
 *		PLUGIN_
 *
 *	l:
 *		֐ vOC_property
 *		ݒ肷vpeBꍇÅ֐͕KvB
 */
__declspec(dllexport) BOOL CALLBACK n01_caller_property(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	// vpeBݒ肵ꍇ PLUGIN_SUCCEED Ԃ
	// ݒ肷vpeBꍇ PLUGIN_ERROR Ԃ
	// ݒ
	DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OPTION), hWnd, option_proc, (LPARAM)0);
	return PLUGIN_SUCCEED;
}

/*
 * func_plugin - vOC
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		call_type - Ăяo@
 *		pei - vOCs
 *		param - Ăяo
 *
 *	߂l:
 *		PLUGIN_
 */
__declspec(dllexport) int CALLBACK n01_caller(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	static BOOL start_flag = FALSE;
	TCHAR buf[BUF_SIZE];
	TCHAR work[BUF_SIZE];

	switch (call_type) {
	case CALLTYPE_START:
		// vOJn
		start_flag = TRUE;
		break;

	case CALLTYPE_MENU:
		// j[
		// ݒ
		if (DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OPTION), hWnd, option_proc, (LPARAM)0) == FALSE) {
			break;
		}
		break;

	case CALLTYPE_LEG_START:
		// bOJn
		// param - ݂̃bO
		if (start_flag == FALSE && snd_enable != 0) {
			if (*snd_path == TEXT('\0')) {
				lstrcpy(buf, TEXT("gameon.wav"));
			} else {
				wsprintf(buf, TEXT("%sgameon.wav"), snd_path);
			}
			sndPlaySound(buf, SND_ASYNC | SND_NODEFAULT);
		}
		start_flag = FALSE;
		break;

	case CALLTYPE_INPUT_END:
		// XRA͊m
		// param - ͂XRA̒l
		// ߂l PLUGIN_CANCEL ԂƃXRA͂m肵Ȃ
		// XRA(pei->si->leg[pei->si->current_leg].score)ύXꍇ PLUGIN_DATA_MODIFIED Ԃ
		if (snd_enable != 0) {
			if (*snd_path == TEXT('\0')) {
				wsprintf(buf, TEXT("%d.wav"), param);
			} else {
				wsprintf(buf, TEXT("%s%d.wav"), snd_path, param);
			}
			sndPlaySound(buf, SND_ASYNC | SND_NODEFAULT);
		}
		break;

	case CALLTYPE_FINISH:
		// tBjbV
		// param - tBjbV{ (-1, -2, -3)
		// param  0 ̏ꍇ̓~htH[fBhł̃tBjbV
		// ߂l PLUGIN_CANCEL ԂƃtBjbVLZ
		// XRA(pei->si->leg[pei->si->current_leg].score)ύXꍇ PLUGIN_DATA_MODIFIED Ԃ
		if (snd_enable != 0) {
			switch (param) {
			case -1:
				lstrcpy(work, TEXT("1st"));
				break;
			case -2:
				lstrcpy(work, TEXT("2nd"));
				break;
			case -3:
				lstrcpy(work, TEXT("3rd"));
				break;
			default:
				lstrcpy(work, TEXT("middle"));
				break;
			}
			if (*snd_path == TEXT('\0')) {
				wsprintf(buf, TEXT("%s.wav"), work);
			} else {
				wsprintf(buf, TEXT("%s%s.wav"), snd_path, work);
			}
			sndPlaySound(buf, SND_ASYNC | SND_NODEFAULT);
		}
		break;
	}
	return PLUGIN_SUCCEED;
}

/*
 * message_get_res - \[X烁bZ[W擾
 */
static TCHAR *message_get_res(const UINT id)
{
	static TCHAR buf[BUF_SIZE];

	*buf = TEXT('\0');
	LoadString(hInst, id, buf, BUF_SIZE - 1);
	return buf;
}

/*
 *	folder_select - tH_I
 */
static BOOL folder_select(const HWND hWnd, const TCHAR *title, TCHAR *ret)
{
	BROWSEINFO bi;
	LPITEMIDLIST lpItemList;
	TCHAR buf[BUF_SIZE];

	bi.hwndOwner = hWnd;
	bi.pidlRoot = (const struct _ITEMIDLIST *)CSIDL_DESKTOP;
	*buf = TEXT('\0');
	bi.pszDisplayName = buf;
	bi.lpszTitle = title;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;	/* tH_͑IłȂ悤ɂ */
	bi.lpfn = NULL;
	bi.lParam = 0;
	bi.iImage = 0;

	/* tH_Iʂ\ */
	lpItemList = SHBrowseForFolder(&bi);
	if(lpItemList == NULL){
		return FALSE;
	}
	/* IĂtH_̃tpX擾 */
	SHGetPathFromIDList(lpItemList, ret);
	return TRUE;
}

/*
 * option_proc - EBhEvV[W
 */
static BOOL CALLBACK option_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	TCHAR buf[BUF_SIZE];
	RECT parent_rect, rect;
	int left, top;

	switch (msg) {
	case WM_INITDIALOG:

		if (snd_enable == 1) {
			CheckDlgButton(hDlg, IDC_CHECK_SOUND_ENABLE, BST_CHECKED);
		}
		SendDlgItemMessage(hDlg, IDC_EDIT_SOUND_PATH, WM_SETTEXT, 0, (LPARAM)snd_path);

		// Z^O
		GetWindowRect(GetParent(hDlg), &parent_rect);
		GetWindowRect(hDlg, &rect);
		left = parent_rect.left + ((parent_rect.right - parent_rect.left) - (rect.right - rect.left)) / 2;
		if (left < 0) left = 0;
		top = parent_rect.top + ((parent_rect.bottom - parent_rect.top) - (rect.bottom - rect.top)) / 2;
		if (top < 0) top = 0;
		SetWindowPos(hDlg, 0, left, top, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BUTTON_BROWS_PATH:
			if (folder_select(hDlg, message_get_res(IDS_STRING_FOLDER_SELECT), buf) == FALSE) {
				break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_SOUND_PATH, WM_SETTEXT, 0, (LPARAM)buf);
			break;

		case IDOK:
			// CSV
			SendDlgItemMessage(hDlg, IDC_EDIT_SOUND_PATH, WM_GETTEXT, MAX_PATH - 1, (LPARAM)snd_path);
			if (*snd_path != TEXT('\0') &&
				*(snd_path + lstrlen(snd_path) - 1) != TEXT('\\') && *(snd_path + lstrlen(snd_path) - 1) != TEXT('/')) {
				lstrcat(snd_path, TEXT("\\"));
			}

			if (IsDlgButtonChecked(hDlg, IDC_CHECK_SOUND_ENABLE) == BST_CHECKED) {
				snd_enable = 1;
			} else {
				snd_enable = 0;
			}

			WritePrivateProfileString(TEXT("SOUND"), TEXT("path"), snd_path, ini_path);
			wsprintf(buf, TEXT("%d"), snd_enable);
			WritePrivateProfileString(TEXT("SOUND"), TEXT("enable"), buf, ini_path);

			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}
/* End of source */
